/* -*- Mode: C; c-basic-offset:4 ; -*- */
/*
 *  (C) 2001 by Argonne National Laboratory.
 *      See COPYRIGHT in top-level directory.
 */

#include "mpi.h"
#include <stdio.h>
#include <string.h>

#define BUFLEN 512

int main(int argc, char *argv[])
{
    int myid, numprocs, next, namelen;
	int i;
    char buffer[BUFLEN], processor_name[MPI_MAX_PROCESSOR_NAME];
    MPI_Status status;

    MPI_Init(&argc,&argv);
    MPI_Comm_size(MPI_COMM_WORLD,&numprocs);
    MPI_Comm_rank(MPI_COMM_WORLD,&myid);
    MPI_Get_processor_name(processor_name,&namelen);

    fprintf(stderr,"Process %d on %s\n", myid, processor_name);
    fprintf(stderr,"Process %d of %d\n", myid, numprocs);
    strcpy(buffer,"hello there");
    if (myid == numprocs-1)
		next = 0;
    else
		next = myid+1;
	for( i =0; i<4; i++ ){
		if (myid == 0)
		{
			printf("%d: %d sending '%s' \n", i, myid, buffer);fflush(stdout);
			MPI_Send(buffer, strlen(buffer)+1, MPI_CHAR, next, 99, MPI_COMM_WORLD);
			printf("%d: %d receiving \n", i, myid);fflush(stdout);
			MPI_Recv(buffer, BUFLEN, MPI_CHAR, MPI_ANY_SOURCE, 99, MPI_COMM_WORLD,&status);
			printf("%d: %d received '%s' \n", i, myid, buffer);fflush(stdout);
			/* mpdprintf(001,"%d receiving \n",myid); */
		}
		else
		{
			printf("%d: %d receiving  \n", i, myid);fflush(stdout);
			MPI_Recv(buffer, BUFLEN, MPI_CHAR, MPI_ANY_SOURCE, 99, MPI_COMM_WORLD,&status);
			printf("%d: %d received '%s' \n", i, myid, buffer);fflush(stdout);
			/* mpdprintf(001,"%d receiving \n",myid); */
			MPI_Send(buffer, strlen(buffer)+1, MPI_CHAR, next, 99, MPI_COMM_WORLD);
			printf("%d: %d sent '%s' \n", i, myid, buffer);fflush(stdout);
		}
		MPI_Barrier(MPI_COMM_WORLD);
	}
	if(myid == 0)
		printf("All processes finished.");
    MPI_Finalize();
    return (0);
}
